# Lier Redmine à garmin par de sms

![tag](python)
![category](Name Of Category)

J'utilise Redmine pour organiser l'ensemble des travaux que je souhaite faire (toutes les tâches de ma journée)

Ma montre Garmin Forerunner 245 est sympa car je peux intégrer une bonne dizaine d'alarme avec des critères poussés ... 
mais malheureusement je ne peux pas lui demandé de vibre et de m'indiquer des infos de mes tâches à faire: ex lundi prochain à 13:35 rappeler le medecin.
Alors que dans Redmine j'ai bien la tache rappeler le medecin pour lundi prochain

J'ai donc crée dans Redmine un nouveau tracker nommé "Remind" avec 

- un champ spécifique "Heure" (format ^[0-2][0-9]:[0-5][0-9]$ et une valeur par défaut à 08:00)
- status New ou Closed
- sans description
- un assigné à
- et repeat (avec le plugin repeat)

Pour chaque utilisateur j'ai rajouter un champ Free_token et Free_user pour l'envoi du sms

j'ai sur le serveur redmine ajouté un tache python qui tourne toutes les 5 minutes

```
try:
    from redminelib import Redmine
except:
    print("you run: pip install Python-Redmine")
    exit()
try:
    import requests
except:
    print("you run: pip install requests")
    exit()
    
from datetime import date, datetime

def sendsms(user, token, msg, url = "https://smsapi.free-mobile.fr/sendmsg"):
    return requests.get(url, {"user" : user, "pass" : token, "msg" : msg})

username = "MYUSER_REDMINE"
password = "**************"
status_closed = 'Closed' 
tracker_name = 'Remind' 
field_hour = 'Heure'

redmine = Redmine('https://todo.fraoustin.fr/', username=username, password=password)
status_closed_id = [status for status in redmine.issue_status.all() if status.name == status_closed][0].id
tracker_id = [tracker for tracker in redmine.tracker.all() if tracker.name == tracker_name][0].id
issues = redmine.issue.filter(
     tracker_id=tracker_id
)
for issue in issues:
    if date.today() >= issue.due_date:
        hour = [field for field in list(issue.custom_fields) if field.name == field_hour][0]
        now = datetime.now()
        timeissue = datetime.strptime("%s %s" % (issue.due_date.strftime("%d/%m/%Y"), hour.value), "%d/%m/%Y %H:%M")
        if now >= timeissue:
            current_user = redmine.user.get(issue.assigned_to.id)
            free_token = [field for field in list(current_user.custom_fields) if field.name == 'Free_token'][0].value
            free_user = [field for field in list(current_user.custom_fields) if field.name == 'Free_user'][0].value
            sendsms(free_user, free_token, issue.subject)
            redmine.issue.update(issue.id, status_id = status_closed_id, notes="send by sms")


```
